#!/usr/bin/env python
# -*- coding: utf-8 -*-

#
# Generated Thu Aug 20 01:49:14 2015 by generateDS.py version 2.12e.
#
# Command line options:
#   ('-o', 'roastrecord.py')
#   ('-s', 'roastrecordsub.py')
#
# Command line arguments:
#   roastrecord.xsd
#
# Command line:
#   ../generateDS.py -o "roastrecord.py" -s "roastrecordsub.py" roastrecord.xsd
#
# Current working directory (os.getcwd()):
#   0_RoastRecord
#

import sys
import getopt
import re as re_
import base64
import datetime as datetime_

etree_ = None
Verbose_import_ = False
(
    XMLParser_import_none, XMLParser_import_lxml,
    XMLParser_import_elementtree
) = range(3)
XMLParser_import_library = None
try:
    # lxml
    from lxml import etree as etree_
    XMLParser_import_library = XMLParser_import_lxml
    if Verbose_import_:
        print("running with lxml.etree")
except ImportError:
    try:
        # cElementTree from Python 2.5+
        import xml.etree.cElementTree as etree_
        XMLParser_import_library = XMLParser_import_elementtree
        if Verbose_import_:
            print("running with cElementTree on Python 2.5+")
    except ImportError:
        try:
            # ElementTree from Python 2.5+
            import xml.etree.ElementTree as etree_
            XMLParser_import_library = XMLParser_import_elementtree
            if Verbose_import_:
                print("running with ElementTree on Python 2.5+")
        except ImportError:
            try:
                # normal cElementTree install
                import cElementTree as etree_
                XMLParser_import_library = XMLParser_import_elementtree
                if Verbose_import_:
                    print("running with cElementTree")
            except ImportError:
                try:
                    # normal ElementTree install
                    import elementtree.ElementTree as etree_
                    XMLParser_import_library = XMLParser_import_elementtree
                    if Verbose_import_:
                        print("running with ElementTree")
                except ImportError:
                    raise ImportError(
                        "Failed to import ElementTree from any known place")


def parsexml_(*args, **kwargs):
    if (XMLParser_import_library == XMLParser_import_lxml and
            'parser' not in kwargs):
        # Use the lxml ElementTree compatible parser so that, e.g.,
        #   we ignore comments.
        kwargs['parser'] = etree_.ETCompatXMLParser()
    doc = etree_.parse(*args, **kwargs)
    return doc

#
# User methods
#
# Calls to the methods in these classes are generated by generateDS.py.
# You can replace these methods by re-implementing the following class
#   in a module named generatedssuper.py.

try:
    from generatedssuper import GeneratedsSuper
except ImportError, exp:

    class GeneratedsSuper(object):
        tzoff_pattern = re_.compile(r'(\+|-)((0\d|1[0-3]):[0-5]\d|14:00)$')
        class _FixedOffsetTZ(datetime_.tzinfo):
            def __init__(self, offset, name):
                self.__offset = datetime_.timedelta(minutes=offset)
                self.__name = name
            def utcoffset(self, dt):
                return self.__offset
            def tzname(self, dt):
                return self.__name
            def dst(self, dt):
                return None
        def gds_format_string(self, input_data, input_name=''):
            return input_data
        def gds_validate_string(self, input_data, node, input_name=''):
            if not input_data:
                return ''
            else:
                return input_data
        def gds_format_base64(self, input_data, input_name=''):
            return base64.b64encode(input_data)
        def gds_validate_base64(self, input_data, node, input_name=''):
            return input_data
        def gds_format_integer(self, input_data, input_name=''):
            return '%d' % input_data
        def gds_validate_integer(self, input_data, node, input_name=''):
            return input_data
        def gds_format_integer_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_integer_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    float(value)
                except (TypeError, ValueError):
                    raise_parse_error(node, 'Requires sequence of integers')
            return input_data
        def gds_format_float(self, input_data, input_name=''):
            return ('%.15f' % input_data).rstrip('0')
        def gds_validate_float(self, input_data, node, input_name=''):
            return input_data
        def gds_format_float_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_float_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    float(value)
                except (TypeError, ValueError):
                    raise_parse_error(node, 'Requires sequence of floats')
            return input_data
        def gds_format_double(self, input_data, input_name=''):
            return '%e' % input_data
        def gds_validate_double(self, input_data, node, input_name=''):
            return input_data
        def gds_format_double_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_double_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    float(value)
                except (TypeError, ValueError):
                    raise_parse_error(node, 'Requires sequence of doubles')
            return input_data
        def gds_format_boolean(self, input_data, input_name=''):
            return ('%s' % input_data).lower()
        def gds_validate_boolean(self, input_data, node, input_name=''):
            return input_data
        def gds_format_boolean_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_boolean_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                if value not in ('true', '1', 'false', '0', ):
                    raise_parse_error(
                        node,
                        'Requires sequence of booleans '
                        '("true", "1", "false", "0")')
            return input_data
        def gds_validate_datetime(self, input_data, node, input_name=''):
            return input_data
        def gds_format_datetime(self, input_data, input_name=''):
            if input_data.microsecond == 0:
                _svalue = '%04d-%02d-%02dT%02d:%02d:%02d' % (
                    input_data.year,
                    input_data.month,
                    input_data.day,
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                )
            else:
                _svalue = '%04d-%02d-%02dT%02d:%02d:%02d.%s' % (
                    input_data.year,
                    input_data.month,
                    input_data.day,
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                    ('%f' % (float(input_data.microsecond) / 1000000))[2:],
                )
            if input_data.tzinfo is not None:
                tzoff = input_data.tzinfo.utcoffset(input_data)
                if tzoff is not None:
                    total_seconds = tzoff.seconds + (86400 * tzoff.days)
                    if total_seconds == 0:
                        _svalue += 'Z'
                    else:
                        if total_seconds < 0:
                            _svalue += '-'
                            total_seconds *= -1
                        else:
                            _svalue += '+'
                        hours = total_seconds // 3600
                        minutes = (total_seconds - (hours * 3600)) // 60
                        _svalue += '{0:02d}:{1:02d}'.format(hours, minutes)
            return _svalue
        @classmethod
        def gds_parse_datetime(cls, input_data):
            tz = None
            if input_data[-1] == 'Z':
                tz = GeneratedsSuper._FixedOffsetTZ(0, 'UTC')
                input_data = input_data[:-1]
            else:
                results = GeneratedsSuper.tzoff_pattern.search(input_data)
                if results is not None:
                    tzoff_parts = results.group(2).split(':')
                    tzoff = int(tzoff_parts[0]) * 60 + int(tzoff_parts[1])
                    if results.group(1) == '-':
                        tzoff *= -1
                    tz = GeneratedsSuper._FixedOffsetTZ(
                        tzoff, results.group(0))
                    input_data = input_data[:-6]
            time_parts = input_data.split('.')
            if len(time_parts) > 1:
                micro_seconds = int(float('0.' + time_parts[1]) * 1000000)
                input_data = '%s.%s' % (time_parts[0], micro_seconds, )
                dt = datetime_.datetime.strptime(
                    input_data, '%Y-%m-%dT%H:%M:%S.%f')
            else:
                dt = datetime_.datetime.strptime(
                    input_data, '%Y-%m-%dT%H:%M:%S')
            dt = dt.replace(tzinfo=tz)
            return dt
        def gds_validate_date(self, input_data, node, input_name=''):
            return input_data
        def gds_format_date(self, input_data, input_name=''):
            _svalue = '%04d-%02d-%02d' % (
                input_data.year,
                input_data.month,
                input_data.day,
            )
            try:
                if input_data.tzinfo is not None:
                    tzoff = input_data.tzinfo.utcoffset(input_data)
                    if tzoff is not None:
                        total_seconds = tzoff.seconds + (86400 * tzoff.days)
                        if total_seconds == 0:
                            _svalue += 'Z'
                        else:
                            if total_seconds < 0:
                                _svalue += '-'
                                total_seconds *= -1
                            else:
                                _svalue += '+'
                            hours = total_seconds // 3600
                            minutes = (total_seconds - (hours * 3600)) // 60
                            _svalue += '{0:02d}:{1:02d}'.format(hours, minutes)
            except AttributeError:
                pass
            return _svalue
        @classmethod
        def gds_parse_date(cls, input_data):
            tz = None
            if input_data[-1] == 'Z':
                tz = GeneratedsSuper._FixedOffsetTZ(0, 'UTC')
                input_data = input_data[:-1]
            else:
                results = GeneratedsSuper.tzoff_pattern.search(input_data)
                if results is not None:
                    tzoff_parts = results.group(2).split(':')
                    tzoff = int(tzoff_parts[0]) * 60 + int(tzoff_parts[1])
                    if results.group(1) == '-':
                        tzoff *= -1
                    tz = GeneratedsSuper._FixedOffsetTZ(
                        tzoff, results.group(0))
                    input_data = input_data[:-6]
            dt = datetime_.datetime.strptime(input_data, '%Y-%m-%d')
            dt = dt.replace(tzinfo=tz)
            return dt.date()
        def gds_validate_time(self, input_data, node, input_name=''):
            return input_data
        def gds_format_time(self, input_data, input_name=''):
            if input_data.microsecond == 0:
                _svalue = '%02d:%02d:%02d' % (
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                )
            else:
                _svalue = '%02d:%02d:%02d.%s' % (
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                    ('%f' % (float(input_data.microsecond) / 1000000))[2:],
                )
            if input_data.tzinfo is not None:
                tzoff = input_data.tzinfo.utcoffset(input_data)
                if tzoff is not None:
                    total_seconds = tzoff.seconds + (86400 * tzoff.days)
                    if total_seconds == 0:
                        _svalue += 'Z'
                    else:
                        if total_seconds < 0:
                            _svalue += '-'
                            total_seconds *= -1
                        else:
                            _svalue += '+'
                        hours = total_seconds // 3600
                        minutes = (total_seconds - (hours * 3600)) // 60
                        _svalue += '{0:02d}:{1:02d}'.format(hours, minutes)
            return _svalue
        @classmethod
        def gds_parse_time(cls, input_data):
            tz = None
            if input_data[-1] == 'Z':
                tz = GeneratedsSuper._FixedOffsetTZ(0, 'UTC')
                input_data = input_data[:-1]
            else:
                results = GeneratedsSuper.tzoff_pattern.search(input_data)
                if results is not None:
                    tzoff_parts = results.group(2).split(':')
                    tzoff = int(tzoff_parts[0]) * 60 + int(tzoff_parts[1])
                    if results.group(1) == '-':
                        tzoff *= -1
                    tz = GeneratedsSuper._FixedOffsetTZ(
                        tzoff, results.group(0))
                    input_data = input_data[:-6]
            if len(input_data.split('.')) > 1:
                dt = datetime_.datetime.strptime(input_data, '%H:%M:%S.%f')
            else:
                dt = datetime_.datetime.strptime(input_data, '%H:%M:%S')
            dt = dt.replace(tzinfo=tz)
            return dt.time()
        def gds_str_lower(self, instring):
            return instring.lower()
        def get_path_(self, node):
            path_list = []
            self.get_path_list_(node, path_list)
            path_list.reverse()
            path = '/'.join(path_list)
            return path
        Tag_strip_pattern_ = re_.compile(r'\{.*\}')
        def get_path_list_(self, node, path_list):
            if node is None:
                return
            tag = GeneratedsSuper.Tag_strip_pattern_.sub('', node.tag)
            if tag:
                path_list.append(tag)
            self.get_path_list_(node.getparent(), path_list)
        def get_class_obj_(self, node, default_class=None):
            class_obj1 = default_class
            if 'xsi' in node.nsmap:
                classname = node.get('{%s}type' % node.nsmap['xsi'])
                if classname is not None:
                    names = classname.split(':')
                    if len(names) == 2:
                        classname = names[1]
                    class_obj2 = globals().get(classname)
                    if class_obj2 is not None:
                        class_obj1 = class_obj2
            return class_obj1
        def gds_build_any(self, node, type_name=None):
            return None
        @classmethod
        def gds_reverse_node_mapping(cls, mapping):
            return dict(((v, k) for k, v in mapping.iteritems()))


#
# If you have installed IPython you can uncomment and use the following.
# IPython is available from http://ipython.scipy.org/.
#

## from IPython.Shell import IPShellEmbed
## args = ''
## ipshell = IPShellEmbed(args,
##     banner = 'Dropping into IPython',
##     exit_msg = 'Leaving Interpreter, back to program.')

# Then use the following line where and when you want to drop into the
# IPython shell:
#    ipshell('<some message> -- Entering ipshell.\nHit Ctrl-D to exit')

#
# Globals
#

ExternalEncoding = 'ascii'
Tag_pattern_ = re_.compile(r'({.*})?(.*)')
String_cleanup_pat_ = re_.compile(r"[\n\r\s]+")
Namespace_extract_pat_ = re_.compile(r'{(.*)}(.*)')

#
# Support/utility functions.
#


def showIndent(outfile, level, pretty_print=True):
    if pretty_print:
        for idx in range(level):
            outfile.write('    ')


def quote_xml(inStr):
    if not inStr:
        return ''
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1


def quote_attrib(inStr):
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    if '"' in s1:
        if "'" in s1:
            s1 = '"%s"' % s1.replace('"', "&quot;")
        else:
            s1 = "'%s'" % s1
    else:
        s1 = '"%s"' % s1
    return s1


def quote_python(inStr):
    s1 = inStr
    if s1.find("'") == -1:
        if s1.find('\n') == -1:
            return "'%s'" % s1
        else:
            return "'''%s'''" % s1
    else:
        if s1.find('"') != -1:
            s1 = s1.replace('"', '\\"')
        if s1.find('\n') == -1:
            return '"%s"' % s1
        else:
            return '"""%s"""' % s1


def get_all_text_(node):
    if node.text is not None:
        text = node.text
    else:
        text = ''
    for child in node:
        if child.tail is not None:
            text += child.tail
    return text


def find_attr_value_(attr_name, node):
    attrs = node.attrib
    attr_parts = attr_name.split(':')
    value = None
    if len(attr_parts) == 1:
        value = attrs.get(attr_name)
    elif len(attr_parts) == 2:
        prefix, name = attr_parts
        namespace = node.nsmap.get(prefix)
        if namespace is not None:
            value = attrs.get('{%s}%s' % (namespace, name, ))
    return value


class GDSParseError(Exception):
    pass


def raise_parse_error(node, msg):
    if XMLParser_import_library == XMLParser_import_lxml:
        msg = '%s (element %s/line %d)' % (
            msg, node.tag, node.sourceline, )
    else:
        msg = '%s (element %s)' % (msg, node.tag, )
    raise GDSParseError(msg)


class MixedContainer:
    # Constants for category:
    CategoryNone = 0
    CategoryText = 1
    CategorySimple = 2
    CategoryComplex = 3
    # Constants for content_type:
    TypeNone = 0
    TypeText = 1
    TypeString = 2
    TypeInteger = 3
    TypeFloat = 4
    TypeDecimal = 5
    TypeDouble = 6
    TypeBoolean = 7
    TypeBase64 = 8
    def __init__(self, category, content_type, name, value):
        self.category = category
        self.content_type = content_type
        self.name = name
        self.value = value
    def getCategory(self):
        return self.category
    def getContenttype(self, content_type):
        return self.content_type
    def getValue(self):
        return self.value
    def getName(self):
        return self.name
    def export(self, outfile, level, name, namespace, pretty_print=True):
        if self.category == MixedContainer.CategoryText:
            # Prevent exporting empty content as empty lines.
            if self.value.strip():
                outfile.write(self.value)
        elif self.category == MixedContainer.CategorySimple:
            self.exportSimple(outfile, level, name)
        else:    # category == MixedContainer.CategoryComplex
            self.value.export(outfile, level, namespace, name, pretty_print)
    def exportSimple(self, outfile, level, name):
        if self.content_type == MixedContainer.TypeString:
            outfile.write('<%s>%s</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeInteger or \
                self.content_type == MixedContainer.TypeBoolean:
            outfile.write('<%s>%d</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeFloat or \
                self.content_type == MixedContainer.TypeDecimal:
            outfile.write('<%s>%f</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeDouble:
            outfile.write('<%s>%g</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeBase64:
            outfile.write('<%s>%s</%s>' % (
                self.name, base64.b64encode(self.value), self.name))
    def to_etree(self, element):
        if self.category == MixedContainer.CategoryText:
            # Prevent exporting empty content as empty lines.
            if self.value.strip():
                if len(element) > 0:
                    if element[-1].tail is None:
                        element[-1].tail = self.value
                    else:
                        element[-1].tail += self.value
                else:
                    if element.text is None:
                        element.text = self.value
                    else:
                        element.text += self.value
        elif self.category == MixedContainer.CategorySimple:
            subelement = etree_.SubElement(element, '%s' % self.name)
            subelement.text = self.to_etree_simple()
        else:    # category == MixedContainer.CategoryComplex
            self.value.to_etree(element)
    def to_etree_simple(self):
        if self.content_type == MixedContainer.TypeString:
            text = self.value
        elif (self.content_type == MixedContainer.TypeInteger or
                self.content_type == MixedContainer.TypeBoolean):
            text = '%d' % self.value
        elif (self.content_type == MixedContainer.TypeFloat or
                self.content_type == MixedContainer.TypeDecimal):
            text = '%f' % self.value
        elif self.content_type == MixedContainer.TypeDouble:
            text = '%g' % self.value
        elif self.content_type == MixedContainer.TypeBase64:
            text = '%s' % base64.b64encode(self.value)
        return text
    def exportLiteral(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            showIndent(outfile, level)
            outfile.write(
                'model_.MixedContainer(%d, %d, "%s", "%s"),\n' % (
                    self.category, self.content_type, self.name, self.value))
        elif self.category == MixedContainer.CategorySimple:
            showIndent(outfile, level)
            outfile.write(
                'model_.MixedContainer(%d, %d, "%s", "%s"),\n' % (
                    self.category, self.content_type, self.name, self.value))
        else:    # category == MixedContainer.CategoryComplex
            showIndent(outfile, level)
            outfile.write(
                'model_.MixedContainer(%d, %d, "%s",\n' % (
                    self.category, self.content_type, self.name,))
            self.value.exportLiteral(outfile, level + 1)
            showIndent(outfile, level)
            outfile.write(')\n')


class MemberSpec_(object):
    def __init__(self, name='', data_type='', container=0):
        self.name = name
        self.data_type = data_type
        self.container = container
    def set_name(self, name): self.name = name
    def get_name(self): return self.name
    def set_data_type(self, data_type): self.data_type = data_type
    def get_data_type_chain(self): return self.data_type
    def get_data_type(self):
        if isinstance(self.data_type, list):
            if len(self.data_type) > 0:
                return self.data_type[-1]
            else:
                return 'xs:string'
        else:
            return self.data_type
    def set_container(self, container): self.container = container
    def get_container(self): return self.container


def _cast(typ, value):
    if typ is None or value is None:
        return value
    return typ(value)

#
# Data representation classes.
#


class roasterlog(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, coffee_name='', description='', self_cupping='', fire_ctrl='', customer='myself', score=-1, start_time=None, end_time=None, duration=0, start_weight=0, end_weight=0, env_temp=0, env_humi=0, first_crack_start=0, first_crack_max=0, first_crack_end=0, second_crack_start=0, second_crack_max=0, second_crack_end=0, record=None):
        self.original_tagname_ = None
        self.coffee_name = coffee_name
        self.description = description
        self.self_cupping = self_cupping
        self.fire_ctrl = fire_ctrl
        self.customer = customer
        self.score = score
        if isinstance(start_time, basestring):
            initvalue_ = datetime_.datetime.strptime(start_time, '%Y-%m-%dT%H:%M:%S')
        else:
            initvalue_ = start_time
        self.start_time = initvalue_
        if isinstance(end_time, basestring):
            initvalue_ = datetime_.datetime.strptime(end_time, '%Y-%m-%dT%H:%M:%S')
        else:
            initvalue_ = end_time
        self.end_time = initvalue_
        self.duration = duration
        self.start_weight = start_weight
        self.end_weight = end_weight
        self.env_temp = env_temp
        self.env_humi = env_humi
        self.first_crack_start = first_crack_start
        self.first_crack_max = first_crack_max
        self.first_crack_end = first_crack_end
        self.second_crack_start = second_crack_start
        self.second_crack_max = second_crack_max
        self.second_crack_end = second_crack_end
        if record is None:
            self.record = []
        else:
            self.record = record
    def factory(*args_, **kwargs_):
        if roasterlog.subclass:
            return roasterlog.subclass(*args_, **kwargs_)
        else:
            return roasterlog(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_coffee_name(self): return self.coffee_name
    def set_coffee_name(self, coffee_name): self.coffee_name = coffee_name
    def get_description(self): return self.description
    def set_description(self, description): self.description = description
    def get_self_cupping(self): return self.self_cupping
    def set_self_cupping(self, self_cupping): self.self_cupping = self_cupping
    def get_fire_ctrl(self): return self.fire_ctrl
    def set_fire_ctrl(self, fire_ctrl): self.fire_ctrl = fire_ctrl
    def get_customer(self): return self.customer
    def set_customer(self, customer): self.customer = customer
    def get_score(self): return self.score
    def set_score(self, score): self.score = score
    def get_start_time(self): return self.start_time
    def set_start_time(self, start_time): self.start_time = start_time
    def get_end_time(self): return self.end_time
    def set_end_time(self, end_time): self.end_time = end_time
    def get_duration(self): return self.duration
    def set_duration(self, duration): self.duration = duration
    def get_start_weight(self): return self.start_weight
    def set_start_weight(self, start_weight): self.start_weight = start_weight
    def get_end_weight(self): return self.end_weight
    def set_end_weight(self, end_weight): self.end_weight = end_weight
    def get_env_temp(self): return self.env_temp
    def set_env_temp(self, env_temp): self.env_temp = env_temp
    def get_env_humi(self): return self.env_humi
    def set_env_humi(self, env_humi): self.env_humi = env_humi
    def get_first_crack_start(self): return self.first_crack_start
    def set_first_crack_start(self, first_crack_start): self.first_crack_start = first_crack_start
    def get_first_crack_max(self): return self.first_crack_max
    def set_first_crack_max(self, first_crack_max): self.first_crack_max = first_crack_max
    def get_first_crack_end(self): return self.first_crack_end
    def set_first_crack_end(self, first_crack_end): self.first_crack_end = first_crack_end
    def get_second_crack_start(self): return self.second_crack_start
    def set_second_crack_start(self, second_crack_start): self.second_crack_start = second_crack_start
    def get_second_crack_max(self): return self.second_crack_max
    def set_second_crack_max(self, second_crack_max): self.second_crack_max = second_crack_max
    def get_second_crack_end(self): return self.second_crack_end
    def set_second_crack_end(self, second_crack_end): self.second_crack_end = second_crack_end
    def get_record(self): return self.record
    def set_record(self, record): self.record = record
    def add_record(self, value): self.record.append(value)
    def insert_record_at(self, index, value): self.record.insert(index, value)
    def replace_record_at(self, index, value): self.record[index] = value
    def hasContent_(self):
        if (
            self.coffee_name is not None or
            self.description is not None or
            self.self_cupping is not None or
            self.fire_ctrl is not None or
            self.customer is not None or
            self.score is not None or
            self.start_time is not None or
            self.end_time is not None or
            self.duration is not None or
            self.start_weight is not None or
            self.end_weight is not None or
            self.env_temp is not None or
            self.env_humi is not None or
            self.first_crack_start is not None or
            self.first_crack_max is not None or
            self.first_crack_end is not None or
            self.second_crack_start is not None or
            self.second_crack_max is not None or
            self.second_crack_end is not None or
            self.record
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='', name_='roasterlog', namespacedef_='', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='roasterlog')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='', name_='roasterlog', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='roasterlog'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='roasterlog', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.coffee_name is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%scoffee_name>%s</%scoffee_name>%s' % (namespace_, self.gds_format_string(quote_xml(self.coffee_name).encode(ExternalEncoding), input_name='coffee_name'), namespace_, eol_))
        if self.description is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sdescription>%s</%sdescription>%s' % (namespace_, self.gds_format_string(quote_xml(self.description).encode(ExternalEncoding), input_name='description'), namespace_, eol_))
        if self.self_cupping is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sself_cupping>%s</%sself_cupping>%s' % (namespace_, self.gds_format_string(quote_xml(self.self_cupping).encode(ExternalEncoding), input_name='self_cupping'), namespace_, eol_))
        if self.fire_ctrl is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sfire_ctrl>%s</%sfire_ctrl>%s' % (namespace_, self.gds_format_string(quote_xml(self.fire_ctrl).encode(ExternalEncoding), input_name='fire_ctrl'), namespace_, eol_))
        if self.customer is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%scustomer>%s</%scustomer>%s' % (namespace_, self.gds_format_string(quote_xml(self.customer).encode(ExternalEncoding), input_name='customer'), namespace_, eol_))
        if self.score is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sscore>%s</%sscore>%s' % (namespace_, self.gds_format_integer(self.score, input_name='score'), namespace_, eol_))
        if self.start_time is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sstart_time>%s</%sstart_time>%s' % (namespace_, self.gds_format_datetime(self.start_time, input_name='start_time'), namespace_, eol_))
        if self.end_time is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%send_time>%s</%send_time>%s' % (namespace_, self.gds_format_datetime(self.end_time, input_name='end_time'), namespace_, eol_))
        if self.duration is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sduration>%s</%sduration>%s' % (namespace_, self.gds_format_integer(self.duration, input_name='duration'), namespace_, eol_))
        if self.start_weight is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sstart_weight>%s</%sstart_weight>%s' % (namespace_, self.gds_format_integer(self.start_weight, input_name='start_weight'), namespace_, eol_))
        if self.end_weight is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%send_weight>%s</%send_weight>%s' % (namespace_, self.gds_format_integer(self.end_weight, input_name='end_weight'), namespace_, eol_))
        if self.env_temp is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%senv_temp>%s</%senv_temp>%s' % (namespace_, self.gds_format_integer(self.env_temp, input_name='env_temp'), namespace_, eol_))
        if self.env_humi is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%senv_humi>%s</%senv_humi>%s' % (namespace_, self.gds_format_integer(self.env_humi, input_name='env_humi'), namespace_, eol_))
        if self.first_crack_start is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sfirst_crack_start>%s</%sfirst_crack_start>%s' % (namespace_, self.gds_format_integer(self.first_crack_start, input_name='first_crack_start'), namespace_, eol_))
        if self.first_crack_max is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sfirst_crack_max>%s</%sfirst_crack_max>%s' % (namespace_, self.gds_format_integer(self.first_crack_max, input_name='first_crack_max'), namespace_, eol_))
        if self.first_crack_end is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sfirst_crack_end>%s</%sfirst_crack_end>%s' % (namespace_, self.gds_format_integer(self.first_crack_end, input_name='first_crack_end'), namespace_, eol_))
        if self.second_crack_start is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%ssecond_crack_start>%s</%ssecond_crack_start>%s' % (namespace_, self.gds_format_integer(self.second_crack_start, input_name='second_crack_start'), namespace_, eol_))
        if self.second_crack_max is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%ssecond_crack_max>%s</%ssecond_crack_max>%s' % (namespace_, self.gds_format_integer(self.second_crack_max, input_name='second_crack_max'), namespace_, eol_))
        if self.second_crack_end is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%ssecond_crack_end>%s</%ssecond_crack_end>%s' % (namespace_, self.gds_format_integer(self.second_crack_end, input_name='second_crack_end'), namespace_, eol_))
        for record_ in self.record:
            record_.export(outfile, level, namespace_, name_='record', pretty_print=pretty_print)
    def exportLiteral(self, outfile, level, name_='roasterlog'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.coffee_name is not None:
            showIndent(outfile, level)
            outfile.write('coffee_name=%s,\n' % quote_python(self.coffee_name).encode(ExternalEncoding))
        if self.description is not None:
            showIndent(outfile, level)
            outfile.write('description=%s,\n' % quote_python(self.description).encode(ExternalEncoding))
        if self.self_cupping is not None:
            showIndent(outfile, level)
            outfile.write('self_cupping=%s,\n' % quote_python(self.self_cupping).encode(ExternalEncoding))
        if self.fire_ctrl is not None:
            showIndent(outfile, level)
            outfile.write('fire_ctrl=%s,\n' % quote_python(self.fire_ctrl).encode(ExternalEncoding))
        if self.customer is not None:
            showIndent(outfile, level)
            outfile.write('customer=%s,\n' % quote_python(self.customer).encode(ExternalEncoding))
        if self.score is not None:
            showIndent(outfile, level)
            outfile.write('score=%d,\n' % self.score)
        if self.start_time is not None:
            showIndent(outfile, level)
            outfile.write('start_time=model_.GeneratedsSuper.gds_parse_datetime("%s"),\n' % self.gds_format_datetime(self.start_time, input_name='start_time'))
        if self.end_time is not None:
            showIndent(outfile, level)
            outfile.write('end_time=model_.GeneratedsSuper.gds_parse_datetime("%s"),\n' % self.gds_format_datetime(self.end_time, input_name='end_time'))
        if self.duration is not None:
            showIndent(outfile, level)
            outfile.write('duration=%d,\n' % self.duration)
        if self.start_weight is not None:
            showIndent(outfile, level)
            outfile.write('start_weight=%d,\n' % self.start_weight)
        if self.end_weight is not None:
            showIndent(outfile, level)
            outfile.write('end_weight=%d,\n' % self.end_weight)
        if self.env_temp is not None:
            showIndent(outfile, level)
            outfile.write('env_temp=%d,\n' % self.env_temp)
        if self.env_humi is not None:
            showIndent(outfile, level)
            outfile.write('env_humi=%d,\n' % self.env_humi)
        if self.first_crack_start is not None:
            showIndent(outfile, level)
            outfile.write('first_crack_start=%d,\n' % self.first_crack_start)
        if self.first_crack_max is not None:
            showIndent(outfile, level)
            outfile.write('first_crack_max=%d,\n' % self.first_crack_max)
        if self.first_crack_end is not None:
            showIndent(outfile, level)
            outfile.write('first_crack_end=%d,\n' % self.first_crack_end)
        if self.second_crack_start is not None:
            showIndent(outfile, level)
            outfile.write('second_crack_start=%d,\n' % self.second_crack_start)
        if self.second_crack_max is not None:
            showIndent(outfile, level)
            outfile.write('second_crack_max=%d,\n' % self.second_crack_max)
        if self.second_crack_end is not None:
            showIndent(outfile, level)
            outfile.write('second_crack_end=%d,\n' % self.second_crack_end)
        showIndent(outfile, level)
        outfile.write('record=[\n')
        level += 1
        for record_ in self.record:
            showIndent(outfile, level)
            outfile.write('model_.logitem(\n')
            record_.exportLiteral(outfile, level, name_='logitem')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'coffee_name':
            coffee_name_ = child_.text
            coffee_name_ = self.gds_validate_string(coffee_name_, node, 'coffee_name')
            self.coffee_name = coffee_name_
        elif nodeName_ == 'description':
            description_ = child_.text
            description_ = self.gds_validate_string(description_, node, 'description')
            self.description = description_
        elif nodeName_ == 'self_cupping':
            self_cupping_ = child_.text
            self_cupping_ = self.gds_validate_string(self_cupping_, node, 'self_cupping')
            self.self_cupping = self_cupping_
        elif nodeName_ == 'fire_ctrl':
            fire_ctrl_ = child_.text
            fire_ctrl_ = self.gds_validate_string(fire_ctrl_, node, 'fire_ctrl')
            self.fire_ctrl = fire_ctrl_
        elif nodeName_ == 'customer':
            customer_ = child_.text
            customer_ = self.gds_validate_string(customer_, node, 'customer')
            self.customer = customer_
        elif nodeName_ == 'score':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'score')
            self.score = ival_
        elif nodeName_ == 'start_time':
            sval_ = child_.text
            dval_ = self.gds_parse_datetime(sval_)
            self.start_time = dval_
        elif nodeName_ == 'end_time':
            sval_ = child_.text
            dval_ = self.gds_parse_datetime(sval_)
            self.end_time = dval_
        elif nodeName_ == 'duration':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'duration')
            self.duration = ival_
        elif nodeName_ == 'start_weight':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'start_weight')
            self.start_weight = ival_
        elif nodeName_ == 'end_weight':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'end_weight')
            self.end_weight = ival_
        elif nodeName_ == 'env_temp':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'env_temp')
            self.env_temp = ival_
        elif nodeName_ == 'env_humi':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'env_humi')
            self.env_humi = ival_
        elif nodeName_ == 'first_crack_start':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'first_crack_start')
            self.first_crack_start = ival_
        elif nodeName_ == 'first_crack_max':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'first_crack_max')
            self.first_crack_max = ival_
        elif nodeName_ == 'first_crack_end':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'first_crack_end')
            self.first_crack_end = ival_
        elif nodeName_ == 'second_crack_start':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'second_crack_start')
            self.second_crack_start = ival_
        elif nodeName_ == 'second_crack_max':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'second_crack_max')
            self.second_crack_max = ival_
        elif nodeName_ == 'second_crack_end':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'second_crack_end')
            self.second_crack_end = ival_
        elif nodeName_ == 'record':
            obj_ = logitem.factory()
            obj_.build(child_)
            self.record.append(obj_)
            obj_.original_tagname_ = 'record'
# end class roasterlog


class logitem(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, second=None, bt=None, power=None, fanlevel=None):
        self.original_tagname_ = None
        self.second = second
        self.bt = bt
        self.power = power
        self.fanlevel = fanlevel
    def factory(*args_, **kwargs_):
        if logitem.subclass:
            return logitem.subclass(*args_, **kwargs_)
        else:
            return logitem(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_second(self): return self.second
    def set_second(self, second): self.second = second
    def get_bt(self): return self.bt
    def set_bt(self, bt): self.bt = bt
    def get_power(self): return self.power
    def set_power(self, power): self.power = power
    def get_fanlevel(self): return self.fanlevel
    def set_fanlevel(self, fanlevel): self.fanlevel = fanlevel
    def hasContent_(self):
        if (
            self.second is not None or
            self.bt is not None or
            self.power is not None or
            self.fanlevel is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='', name_='logitem', namespacedef_='', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='logitem')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='', name_='logitem', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='logitem'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='logitem', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.second is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%ssecond>%s</%ssecond>%s' % (namespace_, self.gds_format_integer(self.second, input_name='second'), namespace_, eol_))
        if self.bt is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sbt>%s</%sbt>%s' % (namespace_, self.gds_format_integer(self.bt, input_name='bt'), namespace_, eol_))
        if self.power is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%spower>%s</%spower>%s' % (namespace_, self.gds_format_integer(self.power, input_name='power'), namespace_, eol_))
        if self.fanlevel is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sfanlevel>%s</%sfanlevel>%s' % (namespace_, self.gds_format_integer(self.fanlevel, input_name='fanlevel'), namespace_, eol_))
    def exportLiteral(self, outfile, level, name_='logitem'):
        level += 1
        already_processed = set()
        self.exportLiteralAttributes(outfile, level, already_processed, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, already_processed, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.second is not None:
            showIndent(outfile, level)
            outfile.write('second=%d,\n' % self.second)
        if self.bt is not None:
            showIndent(outfile, level)
            outfile.write('bt=%d,\n' % self.bt)
        if self.power is not None:
            showIndent(outfile, level)
            outfile.write('power=%d,\n' % self.power)
        if self.fanlevel is not None:
            showIndent(outfile, level)
            outfile.write('fanlevel=%d,\n' % self.fanlevel)
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'second':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'second')
            self.second = ival_
        elif nodeName_ == 'bt':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'bt')
            self.bt = ival_
        elif nodeName_ == 'power':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'power')
            self.power = ival_
        elif nodeName_ == 'fanlevel':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError), exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'fanlevel')
            self.fanlevel = ival_
# end class logitem


GDSClassesMapping = {
    'record': logitem,
}


USAGE_TEXT = """
Usage: python <Parser>.py [ -s ] <in_xml_file>
"""


def usage():
    print USAGE_TEXT
    sys.exit(1)


def get_root_tag(node):
    tag = Tag_pattern_.match(node.tag).groups()[-1]
    rootClass = GDSClassesMapping.get(tag)
    if rootClass is None:
        rootClass = globals().get(tag)
    return tag, rootClass


def parse(inFileName, silence=False):
    doc = parsexml_(inFileName)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'roasterlog'
        rootClass = roasterlog
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    if not silence:
        sys.stdout.write('<?xml version="1.0" ?>\n')
        rootObj.export(
            sys.stdout, 0, name_=rootTag,
            namespacedef_='',
            pretty_print=True)
    return rootObj


def parseEtree(inFileName, silence=False):
    doc = parsexml_(inFileName)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'roasterlog'
        rootClass = roasterlog
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    mapping = {}
    rootElement = rootObj.to_etree(None, name_=rootTag, mapping_=mapping)
    reverse_mapping = rootObj.gds_reverse_node_mapping(mapping)
    if not silence:
        content = etree_.tostring(
            rootElement, pretty_print=True,
            xml_declaration=True, encoding="utf-8")
        sys.stdout.write(content)
        sys.stdout.write('\n')
    return rootObj, rootElement, mapping, reverse_mapping


def parseString(inString, silence=False):
    from StringIO import StringIO
    doc = parsexml_(StringIO(inString))
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'roasterlog'
        rootClass = roasterlog
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    if not silence:
        sys.stdout.write('<?xml version="1.0" ?>\n')
        rootObj.export(
            sys.stdout, 0, name_=rootTag,
            namespacedef_='')
    return rootObj


def parseLiteral(inFileName, silence=False):
    doc = parsexml_(inFileName)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'roasterlog'
        rootClass = roasterlog
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    if not silence:
        sys.stdout.write('#from roastrecord import *\n\n')
        sys.stdout.write('import roastrecord as model_\n\n')
        sys.stdout.write('rootObj = model_.rootClass(\n')
        rootObj.exportLiteral(sys.stdout, 0, name_=rootTag)
        sys.stdout.write(')\n')
    return rootObj


def main():
    args = sys.argv[1:]
    if len(args) == 1:
        parse(args[0])
    else:
        usage()


if __name__ == '__main__':
    #import pdb; pdb.set_trace()
    main()


__all__ = [
    "logitem",
    "roasterlog"
]
